<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/include/MTSignatures.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_m_t_signatures_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">MTSignatures.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_signatures.html">   11</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classsiggen_1_1_m_t_signatures.html">MTSignatures</a></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="keyword">using</span> result_t = std::vector&lt;char&gt;;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        std::mutex m_Mutex;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        std::condition_variable m_CondVarWaitForComplete;   </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keywordtype">size_t</span> m_BlocksWritten { 0 };                       </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keywordtype">size_t</span> m_BlocksTotal { 0 };                         </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keywordtype">size_t</span> m_HashSize { 0 };                            </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        result_t m_Signatures;                              </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_signatures.html#a19341613e5b456f7d8ef16893726bc16">   25</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classsiggen_1_1_m_t_signatures.html#a19341613e5b456f7d8ef16893726bc16">IsComplete</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_BlocksWritten == m_BlocksTotal; }</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <a class="code" href="classsiggen_1_1_m_t_signatures.html#a15d4f98f366679e90a036e44cc422ad2">MTSignatures</a> (<span class="keywordtype">size_t</span> blockCount, <span class="keywordtype">size_t</span> hashSize);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_signatures.html#a8c0c1ca006f51e67e167d9be74662a95">PostResult</a> (<span class="keywordtype">size_t</span> blockIndex, result_t <span class="keyword">const</span> &amp; blockSignature);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_signatures.html#ab926d14daa29ab9c4ff06ff8545e0b34">WaitForComplete</a> ();</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_signatures.html#aefefb4578dd0a3af71eb81148fe9fa16">   51</a></span>&#160;        result_t <span class="keyword">const</span> &amp; <a class="code" href="classsiggen_1_1_m_t_signatures.html#aefefb4578dd0a3af71eb81148fe9fa16">GetResult</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_Signatures; }</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    };</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_aefefb4578dd0a3af71eb81148fe9fa16"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#aefefb4578dd0a3af71eb81148fe9fa16">siggen::MTSignatures::GetResult</a></div><div class="ttdeci">const result_t &amp; GetResult() const</div><div class="ttdoc">get array with result signatures of each block of input</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8h_source.html#l00051">MTSignatures.h:51</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html">siggen::MTSignatures</a></div><div class="ttdoc">thread-safe buffer for resulting block-wise signatures</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8h_source.html#l00011">MTSignatures.h:11</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_ab926d14daa29ab9c4ff06ff8545e0b34"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#ab926d14daa29ab9c4ff06ff8545e0b34">siggen::MTSignatures::WaitForComplete</a></div><div class="ttdeci">void WaitForComplete()</div><div class="ttdoc">waits on the condition until all threads deliver their result</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8cpp_source.html#l00031">MTSignatures.cpp:31</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_a15d4f98f366679e90a036e44cc422ad2"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#a15d4f98f366679e90a036e44cc422ad2">siggen::MTSignatures::MTSignatures</a></div><div class="ttdeci">MTSignatures(size_t blockCount, size_t hashSize)</div><div class="ttdoc">pre-allocates blockCount*hashSize bytes of memory</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8cpp_source.html#l00007">MTSignatures.cpp:7</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_a8c0c1ca006f51e67e167d9be74662a95"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#a8c0c1ca006f51e67e167d9be74662a95">siggen::MTSignatures::PostResult</a></div><div class="ttdeci">void PostResult(size_t blockIndex, result_t const &amp;blockSignature)</div><div class="ttdoc">posting result from another thread</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8cpp_source.html#l00014">MTSignatures.cpp:14</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_a19341613e5b456f7d8ef16893726bc16"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#a19341613e5b456f7d8ef16893726bc16">siggen::MTSignatures::IsComplete</a></div><div class="ttdeci">bool IsComplete() const</div><div class="ttdoc">all of the block signatures arrived</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8h_source.html#l00025">MTSignatures.h:25</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_5a30104352ef4255dc24354b02eb2d20.html">include</a></li><li class="navelem"><b>MTSignatures.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
